export declare enum Runner {
    Npm = "npm",
    Yarn = "yarn"
}
export interface TypescriptStarterCLIOptions {
    readonly appveyor: boolean;
    readonly circleci: boolean;
    readonly description: string;
    readonly domDefinitions: boolean;
    readonly editorconfig: boolean;
    readonly immutable: boolean;
    readonly install: boolean;
    readonly nodeDefinitions: boolean;
    readonly projectName: string;
    readonly runner: Runner;
    readonly strict: boolean;
    readonly travis: boolean;
    readonly vscode: boolean;
}
export interface TypescriptStarterRequiredConfig {
    readonly starterVersion: string;
    readonly install: boolean;
}
export declare type TypescriptStarterUserOptions = TypescriptStarterCLIOptions & TypescriptStarterRequiredConfig;
export declare type TypescriptStarterArgsOptions = TypescriptStarterUserOptions | TypescriptStarterRequiredConfig;
export interface TypescriptStarterInferredOptions {
    readonly githubUsername: string;
    readonly fullName: string;
    readonly email: string;
    readonly repoInfo: {
        readonly repo: string;
        readonly branch: string;
    };
    readonly workingDirectory: string;
}
export interface TypescriptStarterOptions extends TypescriptStarterCLIOptions, TypescriptStarterInferredOptions {
}
export declare function hasCLIOptions(opts: TypescriptStarterArgsOptions): opts is TypescriptStarterUserOptions;
export declare function validateName(input: string): true | string;
export declare function getIntro(columns: number | undefined): string;
/**
 * On Windows, normalize returns "\\" as the path separator.
 * This method normalizes with POSIX.
 */
export declare const normalizePath: (path: string) => string;
